#include <RTClock.h> 
// LCD дисплей --------
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
LiquidCrystal_I2C lcd(0x27, 20, 2);
// BMP180
#include <Adafruit_BMP085.h>
Adafruit_BMP085 bmp;
float temp;
int pres;
// переменные для вывода данных
char s2[128];
char s3[128];
 // прерывание
int millis1 = 0;
int millis2 = 0;
// светодиод на плате
#define LED PC13
// количество дней в месяцах
static  const uint8_t monthDays2[]={31,28,31,30,31,30,31,31,30,31,30,31};
// переменные для даты и времени
typedef struct TimeElements
{ 
  uint8_t Second; 
  uint8_t Minute; 
  uint8_t Hour; 
  uint8_t Wday;
  uint8_t Day;
  uint8_t Month; 
  uint8_t Year;
} TimeElements ; 
uint32_t      dateTime_t;
TimeElements  dateTime;
const String  compTime = __TIME__;
const String  compDate = __DATE__;
RTClock rt (RTCSEL_LSE);
// функция setup
void setup()  
{
  // инициализация светодиода
  pinMode(LED, OUTPUT);  
  // инициализация LCD экрана
  lcd.begin();
  lcd.backlight();
  // формируем знак градуса
  uint8_t temp_cel[8] = {B00010,B00101,B00010,B00000,B00000,B00000,B00000}; //закодировано в двоичной системе значек градуса
  // посылаем знак градуса в память символов дисплея
  lcd.createChar(1, temp_cel);
  // инициализация датчика bmp180
  bmp.begin();
  // получение, запись даты и времени
  dateTime.Second = compTime.substring(6,8).toInt();
  dateTime.Minute = compTime.substring(3,5).toInt();
  dateTime.Hour   = compTime.substring(0,2).toInt();
  dateTime.Day    = compDate.substring(4,6).toInt();
  switch (compDate[0]) 
  {
      case 'J': dateTime.Month = compDate[1] == 'a' ? 1 : dateTime.Month = compDate[2] == 'n' ? 6 : 7; break;
      case 'F': dateTime.Month = 2; break;
      case 'A': dateTime.Month = compDate[2] == 'r' ? 4 : 8; break;
      case 'M': dateTime.Month = compDate[2] == 'r' ? 3 : 5; break;
      case 'S': dateTime.Month = 9; break;
      case 'O': dateTime.Month = 10; break;
      case 'N': dateTime.Month = 11; break;
      case 'D': dateTime.Month = 12; break;
  };
  dateTime.Year = compDate.substring(7,11).toInt() - 1970;
  dateTime_t = makeTime(dateTime);
  if (dateTime_t > rt.getTime()) 
  {
    rt.setTime(dateTime_t);
  }
  // вывод анных на экран
      RTCdisplay();
      RTCdisplay1();
      RTCdisplay2();   
}
// основной цикл
void loop()
{
    if(millis() >= millis1){
      millis1 = millis()+1000; //Обновляем значения раз в 1000 миллисекунд (1 секунду)
      RTCdisplay();
      RTCdisplay2();   
      digitalWrite(LED,!digitalRead(LED));
    }
   if(millis() >= millis2){
      millis2 = millis()+60000; //Обновляем значения раз в 60000 миллисекунд (1 минуту)
      RTCdisplay1();
    }  
}
// функция вывода времени на LCD дисплей
void RTCdisplay()
{
  breakTime(rt.getTime(), dateTime);
  // вывод на lcd экран
  sprintf(s2, "%02u:%02u:%02u", dateTime.Hour, dateTime.Minute, dateTime.Second);
  // выводим данные на экран, setCursor(строка, столбец)
  lcd.setCursor(0, 0);
  lcd.print(s2);
}
// функция вывода даты на LCD дисплей
void RTCdisplay1()
{
  breakTime(rt.getTime(), dateTime);
  sprintf(s3, "%02u %02u %02u", dateTime.Day, dateTime.Month, dateTime.Year+1970);
  // выводим данные на экран, setCursor(строка, столбец)
  lcd.setCursor(0, 1);
  lcd.print(s3);  
}
// функция вывода температуры и давления на LCD дисплей
void RTCdisplay2()
{
  // получаем температуру
  temp = bmp.readTemperature();
  // получаем давление и переводим в мм.рт.ст.
  pres = bmp.readPressure()*0.007501;
  // выводим данные на экран, setCursor(строка, столбец)
  lcd.setCursor(14, 0);
  lcd.print(temp); 
  lcd.setCursor(18, 0);
  char temp2[]={'\1', 67, '\0'}; //Отрисовка градусов Цельсия
  lcd.print( temp2 );
  lcd.setCursor(14, 1);
  lcd.print(pres); 
  lcd.setCursor(18, 1);
  lcd.print("mm"); 
}
// функция преобразования даты и времени
#define LEAP_YEAR(Y)  ( ((1970+Y)>0) && !((1970+Y)%4) && ( ((1970+Y)%100) || !((1970+Y)%400) ) )
#define SECS_PER_MIN  (60UL)
#define SECS_PER_HOUR (3600UL)
#define SECS_PER_DAY  (SECS_PER_HOUR * 24UL)
void breakTime(uint32_t timeInput, struct TimeElements &tm){
  uint8_t year;
  uint8_t month, monthLength;
  uint32_t time;
  unsigned long days;
  time = (uint32_t)timeInput;
  tm.Second = time % 60;
  time /= 60;
  tm.Minute = time % 60;
  time /= 60;
  tm.Hour = time % 24;
  time /= 24;
  tm.Wday = ((time + 4) % 7) + 1;
  year = 0;  
  days = 0;
  while((unsigned)(days += (LEAP_YEAR(year) ? 366 : 365)) <= time) {
    year++;
  }
  tm.Year = year;
  days -= LEAP_YEAR(year) ? 366 : 365;
  time  -= days;
  days=0;
  month=0;
  monthLength=0;
  for (month=0; month<12; month++) {
    if (month==1) {
      if (LEAP_YEAR(year)) {
        monthLength=29;
      } else {
        monthLength=28;
      }
    } else {
      monthLength = monthDays2[month];
    }
    
    if (time >= monthLength) {
      time -= monthLength;
    } else {
        break;
    }
  }
  tm.Month = month + 1;
  tm.Day = time + 1;
}
uint32_t makeTime(struct TimeElements &tm){   
  int i;
  uint32_t seconds;
  seconds= tm.Year*(SECS_PER_DAY * 365);
  for (i = 0; i < tm.Year; i++) {
    if (LEAP_YEAR(i)) {
      seconds +=  SECS_PER_DAY;
    }
  }
  for (i = 1; i < tm.Month; i++) {
    if ( (i == 2) && LEAP_YEAR(tm.Year)) { 
      seconds += SECS_PER_DAY * 29;
    } else {
      seconds += SECS_PER_DAY * monthDays2[i-1];
    }
  }
  seconds+= (tm.Day-1) * SECS_PER_DAY;
  seconds+= tm.Hour * SECS_PER_HOUR;
  seconds+= tm.Minute * SECS_PER_MIN;
  seconds+= tm.Second;
  return (uint32_t)seconds; 
}
